var loading_txt='<div class=cssload-clock></div>';

$('input[type="reset"]').click(function(e){
	var form=$(this).closest('form');
	$(form).find('input[type="text"]').val('');
	$(form).find('input[type="hidden"]').val('');
	$(form).find('input[type="date"]').val('');
	$(form).find('input[type="number"]').val('');
	$(form).find('select').prop("selectedIndex", 0);
	e.preventDefault();
});

function show_window(id=null, html=loading_txt) {
	return $('body').append('<div class="popup" id="'+id+'"><div class="popup_area"><div class="close close_button"><i class="fa fa-times" aria-hidden="true"></i></div><div class="popup_content">'+html+'</div></div></div>');
}

function close_window(elem){
	var w=$(elem).closest('.popup');
	$(w).remove();
}

function load_window(link) {
	var id=$.now();
	show_window(id);
	$('#'+id+' .popup_content').load(link);
}

$('body').on('click', '.close', function (){close_window(this)});

function close_all_window() {
	$('.popup').remove();
}

function ajax_response(response) {
	var res=JSON.parse(response);
    show_window('messege', '<p class="'+res.success+'">'+res.txt+'</p>');
	if(res.next_step) {
		//show_window('loading', loading_txt);
		load_ajax(res.next_step);
	}
	if(res.reroute) {
		location.href=res.reroute;
	}
	if(res.reload) {
		var elem=res.reload;
		var href=$(elem).attr('href');
		if(res.id) {
			if(href.indexOf('?')>0) {
				href+='&';
			}
			else {
				href+='?';
			}
			href+='id='+res.id;
		}
		show_window('loading', loading_txt);
		$(elem).load(href+' .reload', function(){
			if(res.close_all_window) {
				close_all_window();
			}
		});
	}
}

function load_ajax(href) {
	show_window('loading', loading_txt);
	$.ajax({
        url: href,
        dataType: "html",
        success: function(response) {
        	close_all_window();
       		var isJson = true;
        	var res;
        	try {
    			res=JSON.parse(response);
			} catch(e) {
    			isJson = false;
			}
       		if(isJson) {
       			ajax_response(response);
       		}
       		else {
       			show_window(null, response);
       		}
    	},
    	error: function(response) {
            $("#error .popup_content").html(response.statusText);
    	}
 	});
}

function send_form(form) {
	action=$(form).attr('action');
	if(action==undefined)action='';
	var method=$(form).attr('method');
	if(method==undefined)action='GET';
	var formData = $(form).serialize();
	show_window('loading', loading_txt);
	$.ajax({
        url: action,
        type: method,
        dataType: "html",
        data: formData,
        success: function(response) {
        	$("#loading").remove();
        	var isJson = true;
        	var res;
        	try {
    			res=JSON.parse(response);
			} catch(e) {
    			isJson = false;
			}
       		if(isJson) {
       			ajax_response(response);
       		}
       		else {
       			show_window(null, response);
       		}
    	},
    	error: function(response) {
            $("#error .popup_content").html(response.statusText);
    	}
 	});
}

$('body').on('click', '.popup .pagination a', function(e){
	var href=$(this).attr('href');
	close_window(this);
	load_window(href);
	e.preventDefault();
});

$('body').on('click', '.show_window', function(e){
	var href=$(this).attr('href');
	load_window(href);
	e.preventDefault();
});

$('body').on('click', '.send_ajax', function(e){
	var href=$(this).attr('href');
	load_ajax(href);
	e.preventDefault();
});

$('body').on('click', '.gen_pass', function(){
	var input=$('input[name="'+$(this).attr('for')+'"]');
	var l=$(this).attr('length');
	if(l==undefined || l==null) {
		l=6;
	}
	var pass="";
	var words='0123456789qwertyuiopasdfghjklzxcvbnmQWERTYUIOPASDFGHJKLZXCVBNM';
	var max_pos=words.length-1;
	for(i=0; i<l; i++) {
		pos=Math.floor(Math.random()*max_pos);
		pass+=words.substring(pos, pos+1);
	}
	input.val(pass);
});

$('body').on('submit', 'form:not(.no_ajax)', function(e){
	send_form(this);
	e.preventDefault();
});

// Экранная цифровая клавиатура

// Цифры
$('body').on('click', '.virtual_key', function(){
	var el=$('.'+$(this).attr('for')).eq(0);
	var val=el.val()+$(this).val();
	el.val(val);
	if(!el.is(':focus')) el.focus();
});

// очистить
$('body').on('click', '.virtual_key_delete', function(){
	var el=$('.'+$(this).attr('for'));
	var form=$(el).closest('form');
	$(form).find('input[type="text"]').val('');
	$(form).find('input[type="password"]').val('');
	
	$(form).find('select').prop('selectedIndex',0);
	$(form).find('select').trigger('change');
	//$(form).trigger("reset");
	$(el).focus();
});

// удалить символ
$('body').on('click', '.virtual_key_bks', function(){
	var val=$('.'+$(this).attr('for')).val();
	val=val.substr(0, val.length-1);
	$('.'+$(this).attr('for')).val(val);
	$('.'+$(this).attr('for')).focus();
});

$('body').on('submit', 'form[name="messeges_continue_form"]', function(){
	close_window(this);
});

$('#smile').click(function(){
	$('body').toggleClass('body_replace');
});

// Автоматическая синхронизация
function synchronization() {
	$('#synchronization_status').html('');
	var dt = new Date();
	var time = dt.getMinutes();
	if(time%synchronization_timer!=0) return;
	$('#synchronization_status').html('Идет синхронизация...');
	$.ajax({
        url: '/api/auto',
        dataType: "html",
        success: function(response) {
        	var res;
        	try {
    			res=JSON.parse(response);
    			var res=JSON.parse(response);
        		$('#synchronization_status').html(res.txt);
        		setTimeout('$("#synchronization_status").html("");', 10000)
			} catch(e) {
    			$('#synchronization_status').html('');
			}
    	}
 	});
}
synchronization();
setInterval('synchronization()', 60000)